import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataJiraFieldConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/data-sources/field#name DataJiraField#name}
    */
    readonly name: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/data-sources/field jira_field}
*/
export declare class DataJiraField extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "jira_field";
    /**
    * Generates CDKTF code for importing a DataJiraField resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataJiraField to import
    * @param importFromId The id of the existing DataJiraField that should be imported. Refer to the {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/data-sources/field#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataJiraField to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/data-sources/field jira_field} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataJiraFieldConfig
    */
    constructor(scope: Construct, id: string, config: DataJiraFieldConfig);
    get clauseNames(): string[];
    get custom(): cdktf.IResolvable;
    get id(): string;
    get key(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    get navigable(): cdktf.IResolvable;
    get searchable(): cdktf.IResolvable;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
