import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataJiraJqlConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/data-sources/jql#id DataJiraJql#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/data-sources/jql#jql DataJiraJql#jql}
    */
    readonly jql: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/data-sources/jql jira_jql}
*/
export declare class DataJiraJql extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "jira_jql";
    /**
    * Generates CDKTF code for importing a DataJiraJql resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataJiraJql to import
    * @param importFromId The id of the existing DataJiraJql that should be imported. Refer to the {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/data-sources/jql#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataJiraJql to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/data-sources/jql jira_jql} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataJiraJqlConfig
    */
    constructor(scope: Construct, id: string, config: DataJiraJqlConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    get issueKeys(): string[];
    private _jql?;
    get jql(): string;
    set jql(value: string);
    get jqlInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
