import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface IssueLinkConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/issue_link#id IssueLink#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/issue_link#inward_key IssueLink#inward_key}
    */
    readonly inwardKey: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/issue_link#link_type IssueLink#link_type}
    */
    readonly linkType: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/issue_link#outward_key IssueLink#outward_key}
    */
    readonly outwardKey: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/issue_link jira_issue_link}
*/
export declare class IssueLink extends cdktf.TerraformResource {
    static readonly tfResourceType = "jira_issue_link";
    /**
    * Generates CDKTF code for importing a IssueLink resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the IssueLink to import
    * @param importFromId The id of the existing IssueLink that should be imported. Refer to the {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/issue_link#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the IssueLink to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/issue_link jira_issue_link} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options IssueLinkConfig
    */
    constructor(scope: Construct, id: string, config: IssueLinkConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _inwardKey?;
    get inwardKey(): string;
    set inwardKey(value: string);
    get inwardKeyInput(): string | undefined;
    private _linkType?;
    get linkType(): string;
    set linkType(value: string);
    get linkTypeInput(): string | undefined;
    private _outwardKey?;
    get outwardKey(): string;
    set outwardKey(value: string);
    get outwardKeyInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
