import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ProjectConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#assignee_type Project#assignee_type}
    */
    readonly assigneeType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#avatar_id Project#avatar_id}
    */
    readonly avatarId?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#category_id Project#category_id}
    */
    readonly categoryId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#description Project#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#id Project#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#issue_security_scheme Project#issue_security_scheme}
    */
    readonly issueSecurityScheme?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#key Project#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#lead Project#lead}
    */
    readonly lead?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#lead_account_id Project#lead_account_id}
    */
    readonly leadAccountId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#name Project#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#notification_scheme Project#notification_scheme}
    */
    readonly notificationScheme?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#permission_scheme Project#permission_scheme}
    */
    readonly permissionScheme?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#project_template_key Project#project_template_key}
    */
    readonly projectTemplateKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#project_type_key Project#project_type_key}
    */
    readonly projectTypeKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#shared_configuration_project_id Project#shared_configuration_project_id}
    */
    readonly sharedConfigurationProjectId?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#url Project#url}
    */
    readonly url?: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project jira_project}
*/
export declare class Project extends cdktf.TerraformResource {
    static readonly tfResourceType = "jira_project";
    /**
    * Generates CDKTF code for importing a Project resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the Project to import
    * @param importFromId The id of the existing Project that should be imported. Refer to the {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the Project to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/fourplusone/jira/0.1.20/docs/resources/project jira_project} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ProjectConfig
    */
    constructor(scope: Construct, id: string, config: ProjectConfig);
    private _assigneeType?;
    get assigneeType(): string;
    set assigneeType(value: string);
    resetAssigneeType(): void;
    get assigneeTypeInput(): string | undefined;
    private _avatarId?;
    get avatarId(): number;
    set avatarId(value: number);
    resetAvatarId(): void;
    get avatarIdInput(): number | undefined;
    private _categoryId?;
    get categoryId(): string;
    set categoryId(value: string);
    resetCategoryId(): void;
    get categoryIdInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _issueSecurityScheme?;
    get issueSecurityScheme(): number;
    set issueSecurityScheme(value: number);
    resetIssueSecurityScheme(): void;
    get issueSecuritySchemeInput(): number | undefined;
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _lead?;
    get lead(): string;
    set lead(value: string);
    resetLead(): void;
    get leadInput(): string | undefined;
    private _leadAccountId?;
    get leadAccountId(): string;
    set leadAccountId(value: string);
    resetLeadAccountId(): void;
    get leadAccountIdInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _notificationScheme?;
    get notificationScheme(): number;
    set notificationScheme(value: number);
    resetNotificationScheme(): void;
    get notificationSchemeInput(): number | undefined;
    private _permissionScheme?;
    get permissionScheme(): number;
    set permissionScheme(value: number);
    resetPermissionScheme(): void;
    get permissionSchemeInput(): number | undefined;
    get projectId(): number;
    private _projectTemplateKey?;
    get projectTemplateKey(): string;
    set projectTemplateKey(value: string);
    resetProjectTemplateKey(): void;
    get projectTemplateKeyInput(): string | undefined;
    private _projectTypeKey?;
    get projectTypeKey(): string;
    set projectTypeKey(value: string);
    resetProjectTypeKey(): void;
    get projectTypeKeyInput(): string | undefined;
    private _sharedConfigurationProjectId?;
    get sharedConfigurationProjectId(): number;
    set sharedConfigurationProjectId(value: number);
    resetSharedConfigurationProjectId(): void;
    get sharedConfigurationProjectIdInput(): number | undefined;
    private _url?;
    get url(): string;
    set url(value: string);
    resetUrl(): void;
    get urlInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
